//this file is part of eMule
//Copyright (C)2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "emule.h"
#include "SplashScreen.h"
#include "OtherFunctions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif


IMPLEMENT_DYNAMIC(CSplashScreen, CDialog)

BEGIN_MESSAGE_MAP(CSplashScreen, CDialog)
	ON_WM_PAINT()
END_MESSAGE_MAP()

CSplashScreen::CSplashScreen(CWnd* pParent /*=NULL*/)
	: CDialog(CSplashScreen::IDD, pParent)
{
	m_hThread = FALSE;
	m_bExitThread = FALSE;
	frames = 0;
	imgWidth = 0;
	imgHeight = 0;
	m_imgSplash = NULL;
}

CSplashScreen::~CSplashScreen()
{
	m_bExitThread = TRUE;
	if (m_hThread)
	{
		WaitForSingleObject(m_hThread,2000);
		CloseHandle(m_hThread);
		m_hThread = NULL;
	}
}

void CSplashScreen::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CSplashScreen::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitWindowStyles(this);

	m_imgSplash.LoadResource(FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(SPLASH), _T("GIF")), CXIMAGE_FORMAT_GIF);
	frames = m_imgSplash.GetNumFrames();
	//VERIFY( m_imgSplash.Attach(theApp.LoadImage(_T("SPLASH"), _T("JPG"))) ); // bobo
	if (m_imgSplash.IsValid())
	{
			imgWidth = m_imgSplash.GetWidth();
			imgHeight = m_imgSplash.GetHeight();
			WINDOWPLACEMENT wp;
			GetWindowPlacement(&wp);
			wp.rcNormalPosition.right = wp.rcNormalPosition.left + imgWidth;
			wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + imgHeight;
			SetWindowPlacement(&wp);
	}
	unsigned int nDummy;
	m_hThread = (HANDLE) _beginthreadex(NULL,0,_PaintGif,this,
		CREATE_SUSPENDED,&nDummy);
	if (!m_hThread)
		return FALSE;
	else 
	{
		ResumeThread(m_hThread);
		SetThreadPriority(m_hThread, THREAD_PRIORITY_ABOVE_NORMAL);
	}

	return true;
}

BOOL CSplashScreen::PreTranslateMessage(MSG* pMsg)
{
	BOOL bResult = CDialog::PreTranslateMessage(pMsg);

	if ((pMsg->message == WM_KEYDOWN	   ||
		 pMsg->message == WM_SYSKEYDOWN	   ||
		 pMsg->message == WM_LBUTTONDOWN   ||
		 pMsg->message == WM_RBUTTONDOWN   ||
		 pMsg->message == WM_MBUTTONDOWN   ||
		 pMsg->message == WM_NCLBUTTONDOWN ||
		 pMsg->message == WM_NCRBUTTONDOWN ||
		 pMsg->message == WM_NCMBUTTONDOWN))
	{
		DestroyWindow();
	}

	return bResult;
}

void CSplashScreen::OnPaint() 
{	
}

UINT WINAPI CSplashScreen::_PaintGif (LPVOID param) 
{ 
	ASSERT(param);
	CSplashScreen *pKlasse = (CSplashScreen*)param;
	pKlasse->PaintGif();
	// this thread has finished its work so we close the handle
	CloseHandle(pKlasse->m_hThread); 
	pKlasse->m_hThread = 0;
	return 0;
}

void CSplashScreen::PaintGif()
{
	CPaintDC dc(this); // device context for painting

#ifdef _UNDEFINED //OLDER_VERSION
	for(int i=0;i</*frames*/27;i++)
	{
		//The first frame is already loaded
		if(i!=0)
		{
			m_imgSplash.SetFrame(i+1);
			m_imgSplash.LoadResource(FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(SPLASH), _T("GIF")), CXIMAGE_FORMAT_GIF);
		}
		HBITMAP m_bitmap = m_imgSplash.MakeBitmap();
		if (dcMem[i].dc.CreateCompatibleDC(&dc))
			if (m_bitmap)
				dcMem[i].dc.SelectObject(m_bitmap);
		m_imgSplash.Destroy();
	}
	i=0;
	while(!m_bExitThread)
	{
		dc.BitBlt(0, 0, imgWidth, imgHeight, &dcMem[i].dc, 0, 0, SRCCOPY);
		Sleep(100);
		if(m_bExitThread) break;
		i++;
		i%=/*frames*/27;
	}
#else
	int i = 0;
	CDC dcMem;
	DWORD curTime;
	curTime = ::GetTickCount();
	while(!m_bExitThread)
	{
		m_imgSplash.SetFrame(i);
		m_imgSplash.LoadResource(FindResource(AfxGetResourceHandle(), MAKEINTRESOURCE(SPLASH), _T("GIF")), CXIMAGE_FORMAT_GIF);
		HBITMAP m_bitmap = m_imgSplash.MakeBitmap();
		if (dcMem.CreateCompatibleDC(&dc))
		{
			if (m_bitmap)
			{
				dcMem.SelectObject(m_bitmap);
				if(i!=0)
				{
					const DWORD diff = min(GetTickCount() - curTime, 100);
					Sleep(100-diff);
				}
				dc.BitBlt(0, 0, imgWidth, imgHeight, &dcMem, 0, 0, SRCCOPY);
				curTime = ::GetTickCount();
			}
			dcMem.DeleteDC();
		}
		m_imgSplash.Destroy();
		
		Sleep(90);
		if(m_bExitThread) break;
		i++;
		i%=frames;
	}
#endif
}